package com.haochuan.hciptvbasic.util;

import android.content.Context;
import android.text.TextUtils;

import com.haochuan.core.Logger;
import com.haochuan.core.http.RequestServer;
import com.haochuan.core.http.ResponseListener;
import com.haochuan.core.http.bean.ApkSettingBean;
import com.haochuan.core.http.bean.ResponseBean;
import com.haochuan.core.util.ELS;

import java.util.List;

/**
 * @author: xulin
 * @projectName:HcIPTVBasic
 * @createTime:2020/7/22 18:32
 */
public class ELSUtil {
    public static void Init(Context context, final ELS els, String uid){
        //访问接口确定是否需要上传日志
        if (!TextUtils.isEmpty(uid)) {
            RequestServer.getInstance().getApkSetting(uid, new ResponseListener<ApkSettingBean>() {
                @Override
                public void onSuccess(ApkSettingBean response) {
                    Logger.d("getApkSetting:" + response.toString());
                    List<ApkSettingBean.DataBean> dataList = response.getData();
                    for (ApkSettingBean.DataBean data : dataList) {
                        //遍历寻找对应配置
                        if ("open_apk_log_status".equals(data.getSetting_name())) {
                            if ("1".equals(data.getSetting_value())) {
                                Logger.setLogNeedWriteToFile(true);
                                els.saveBoolData(ELS.LAST_LOG_SWITCH, true);
                            } else {
                                els.saveBoolData(ELS.LAST_LOG_SWITCH, false);
                            }
                        }
                    }
                }

                @Override
                public void onFailure(String code, String message) {
                    els.saveBoolData(ELS.LAST_LOG_SWITCH, false);
                }
            });
        }

        //每次启动应用时,检查一下上一次使用是否要上传日志,
        // 因为在应用关闭时上传文件可能导致内存内泄漏或上传失败,所以放在应用启动时上传
        if (els.getBoolData(ELS.LAST_LOG_SWITCH)) {
            String lasLogFileName = els.getStringData(ELS.LOG_FILE_NAME);
            Logger.d("uploadLogFile lasLogFileName:" + lasLogFileName);
            if (!TextUtils.isEmpty(lasLogFileName)) {
                RequestServer.getInstance().uploadLogFile(lasLogFileName,
                        new ResponseListener<ResponseBean>() {
                            @Override
                            public void onSuccess(ResponseBean response) {
                                Logger.d("uploadLogFile:" + response.toString());
                            }

                            @Override
                            public void onFailure(String code, String message) {
                                Logger.d("uploadLogFile fail:" + message);
                            }
                        });
            }
        }
    }
}
